#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);


    ll n;
    cin >> n;
    vll h(n);
    for (int i = 0; i < n; ++i)
        cin >> h[i];
    vll req(n - 1);
    for (int i = 0; i < n - 1; ++i)
        cin >> req[i];
    if (*max_element(all(req)) == 1) {
        vector<vll> st;
        vll st_max;
        st.push_back({h[0], 0, 0});
        st_max.push_back(h[0]);
        ll sum = 0;
        for (int i = 1; i < n; ++i) {
            if (h[i] <= st_max.back()) {
                vll res = {h[i], 0, 0};
                while (st.size() && st.back()[0] < h[i]) {
                    res[1] += st.back()[1] + 1;
                    res[2] += st.back()[2] + (h[i] - st.back()[0]) * (st.back()[1] + 1);
                    sum -= st.back()[2];
                    st.pop_back();
                    st_max.pop_back();
                }
                st.push_back(res);
                st_max.push_back(max(st_max.back(), h[i]));
                sum += res[2];
            } else {
                st_max.push_back(h[i]);
                st.push_back({h[i], 0, 0});
            }
            cout << sum << '\n';
        }
    } else {
        cout << 1;
    }

}