#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

#pragma GCC optimize("O3")

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);


    ll n;
    cin >> n;
    vll h(n);
    for (int i = 0; i < n; ++i)
        cin >> h[i];
    vll req(n - 1);
    for (int i = 0; i < n - 1; ++i)
        cin >> req[i];
    if (*max_element(all(req)) == 1) {
        vector<vll> st;
        vll st_max;
        st.push_back({h[0], 0, 0});
        st_max.push_back(h[0]);
        ll sum = 0;
        for (int i = 1; i < n; ++i) {
            vll res = {h[i], i, 0};
            vll last = {-1, -1, -1};
            while (st.size() && st.back()[0] < h[i]) {
                res[2] += st.back()[2];
                sum -= st.back()[2];
                if (last[0] != -1)
                    res[2] += (i - st.back()[1] - 1) * (st.back()[0] - last[0]);
                last = st.back();
                st.pop_back();
                st_max.pop_back();
            }
            if (st.size() && last[0] != -1)
                res[2] += (i - st.back()[1] - 1) * (h[i] - last[0]);
            sum += res[2];
            st.push_back(res);
            st_max.push_back(max(st_max.back(), h[i]));

            cout << sum << '\n';
        }
    } else {
        vector<pair<vector<vll>, vll>> stacks(n);
        for (int i = 0; i < n; ++i) {
            stacks[i].first.push_back({h[i], i, 0});
            stacks[i].second.push_back(h[i]);
        }

        ll sum = 0;
        vector<vll> vec(n);
        for (int i = 0; i < n; ++i)
            vec[i].push_back(i);

        for (auto k : req) {
            k--;
            /*
            ll left_max_ind = stacks[k + 1].first[0][1];
            ll hi = stacks[k + 1].first[0][0];
            vll res = {hi, left_max_ind, stacks[k + 1].first[0][2]};
            vll last = {-1, -1, -1};
            while (stacks[k].first.size() && stacks[k].first.back()[0] < hi) {
                res[2] += stacks[k].first.back()[2];
                sum -= stacks[k].first.back()[2];
                if (last[0] != -1)
                    res[2] += (left_max_ind - stacks[k].first.back()[1] - 1) * (stacks[k].first.back()[0] - last[0]);
                last = stacks[k].first.back();
                stacks[k].first.pop_back();
                stacks[k].second.pop_back();
            }
            if (last[0] != -1)
                res[2] += (left_max_ind - stacks[k].first.back()[1] - 1) * (hi - last[0]);
            sum += res[2];
            stacks[k].first.push_back(res);
            stacks[k].second.push_back(max(stacks[k].second.back(), hi));*/
            for (auto i : vec[k + 1]) {
                vll res = {h[i], i, 0};
                vll last = {-1, -1, -1};
                while (stacks[k].first.size() && stacks[k].first.back()[0] < h[i]) {
                    res[2] += stacks[k].first.back()[2];
                    sum -= stacks[k].first.back()[2];
                    if (last[0] != -1)
                        res[2] += (i - stacks[k].first.back()[1] - 1) * (stacks[k].first.back()[0] - last[0]);
                    last = stacks[k].first.back();
                    stacks[k].first.pop_back();
                    stacks[k].second.pop_back();
                }
                if (stacks[k].first.size() && last[0] != -1)
                    res[2] += (i - stacks[k].first.back()[1] - 1) * (h[i] - last[0]);
                sum += res[2];
                stacks[k].first.push_back(res);
                stacks[k].second.push_back(max(stacks[k].second.back(), h[i]));
            }
            //cout << sum << '\n';
            for (auto el : vec[k + 1])
                vec[k].push_back(el);
            vec.erase(vec.begin() + k + 1);
            stacks.erase(stacks.begin() + k + 1);

            ll res = 0;
            for (auto el : stacks[k].first)
                res += el[2];
            cout << res << '\n';
        }
    }

}