#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll d, l, r;
    cin >> d >> l >> r;

    ll cnt = 0;
    for (ll i = 1; i <= min(1e8, sqrt(r) + 1); ++i) {
        ll x = i * i;
        ll y = x - d;
        if (l <= y && y <= r && l <= x && x <= r && sqrt(y) == ll(sqrt(y))) {
            cnt++;
        }
    }
    cout << cnt << '\n';
}