#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll n, s;
    cin >> n >> s;
    vector<vll> vec(n);
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            ll a;
            cin >> a;
            vec[i].push_back(a);
        }
    }

    vector<vll> dp(vec[0].size() + 1, vll(s + 1, 0));
    vector<vector<pll>> path(vec[0].size() + 1, vector<pll>(s + 1, {0, 0}));
    dp[0][0] = 1;
    for (int i = 1; i <= vec[0].size(); ++i) {
        for (int j = s; j >= 0; --j) {
            dp[i][j] = dp[i - 1][j];
            if (dp[i - 1][j] == 1) {
                dp[i][j] = dp[i - 1][j];
                path[i][j] = {i - 1, j};
            } else if (j >= vec[0][i - 1] && dp[i - 1][j - vec[0][i - 1]] == 1) {
                dp[i][j] = dp[i - 1][j - vec[0][i - 1]];
                path[i][j] = {i - 1, j - vec[0][i - 1]};
            }
        }
    }
    if (dp[vec[0].size()][s]) {
        cout << "Yes\n";
        vll res;
        pll v = {vec[0].size(), s};
        while (v != pll{0, 0}) {
            if (path[v.first][v.second].second != v.second)
                res.push_back(v.first);
            v = path[v.first][v.second];
        }
        cout << res.size() << '\n';
        for (auto el : res)
            cout << el << ' ';
    } else
        cout << "No";
}