#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

ll func(vll& x) {
    vll primes = {2, 3, 5, 7};
    vector<vector<vector<vll>>> dp(x.size(), vector<vector<vll>>(10, vector<vll>(2, vll(2, 0))));
    ll res = 0;

    dp[0][0][0][0] = 1;
    if (x[0] == 1)
        dp[0][1][1][0] = 1;
    else
        dp[0][1][0][0] = 1;

    for (auto el : primes) {
        if (el < x[0])
            dp[0][el][0][1] = 1;
        else if (el == x[0])
            dp[0][el][1][1] = 1;
        else
            break;
    }

    for (int i = 0; i < x.size() - 1; ++i ) {
        for (auto el : vll {0, 1, 2, 3, 5, 7}) {
            for (int f = 0; f < 2; ++f) {
                if (el == 0) {
                    dp[i + 1][0][0][0] += dp[i][el][f][0];
                    dp[i + 1][1][0][0] += dp[i][el][f][0];

                    for (auto d : vll {2, 3, 5, 7})
                        dp[i + 1][d][0][1] += dp[i][el][f][0];

                } else if (el == 1) {
                    for (ll f2 = 0; f2 < 2; ++f2) {
                        if (f2) {
                            if (f) {
                                if (1 < x[i + 1])
                                    dp[i + 1][1][0][1] += dp[i][el][f][f2];
                                else if (1 == x[i + 1])
                                    dp[i + 1][1][1][1] += dp[i][el][f][f2];
                            } else {
                                dp[i + 1][1][0][1] += dp[i][el][f][f2];
                            }
                        } else {
                            if (f) {
                                // 1
                                if (1 < x[i + 1])
                                    dp[i + 1][1][0][0] += dp[i][el][f][f2];
                                else if (1 == x[i + 1])
                                    dp[i + 1][1][1][0] += dp[i][el][f][f2];


                                for (auto d : vll {2, 3, 5, 7}) {
                                    if (d < x[i + 1])
                                        dp[i + 1][d][0][1] += dp[i][el][f][f2];
                                    else if (d == x[i + 1])
                                        dp[i + 1][d][1][1] += dp[i][el][f][f2];
                                    else
                                        break;
                                }
                            } else {
                                dp[i + 1][1][0][0] += dp[i][el][f][0];

                                for (auto d : vll {2, 3, 5, 7})
                                    dp[i + 1][d][0][1] += dp[i][el][f][f2];
                            }
                        }
                    }
                } else {
                    if (f) {
                        if (1 < x[i + 1])
                            dp[i + 1][1][0][1] += dp[i][el][f][1];
                        else if (1 == x[i + 1])
                            dp[i + 1][1][1][1] += dp[i][el][f][1];
                    } else {
                        dp[i + 1][1][0][1] += dp[i][el][f][1];
                    }
                }
            }
        }
    }

    for (auto el : vll{1, 2, 3, 5, 7}) {
        res += dp[x.size() - 1][el][0][1];
        res += dp[x.size() - 1][el][1][1];
    }
    return res;
}

bool is_prpr(vll& x) {
    bool f = true;
    ll res = 1;
    for (auto el : x) {
        res *= el;
        if ((res != 2) && (res != 3) && (res != 5) && (res != 7) && (res != 1))
            return false;
    }
    if (res == 1)
        return false;
    return true;
}

ll solve(vll& l, vll & r) {
    ll r1 = func(r);
    ll r2 = func(l);
    return r1 - r2 + is_prpr(l);
}

ll solve2(ll l, ll r) {
    ll res = 0;
    for (ll i = l; i <= r; ++i) {
        string s = to_string(i);
        vll sl(s.size());
        for (ll j = 0; j < sl.size(); ++j)
            sl[j] = s[j] - '0';
        res += is_prpr(sl);
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);


    string lll, rr;
    cin >> lll >> rr;

    vll l(lll.size()), r(rr.size());
    for (int i = 0; i < lll.size(); i++)
        l[i] = lll[i] - '0';
    for (int i = 0; i < rr.size(); i++)
        r[i] = rr[i] - '0';

    ll r1 = func(r);
    ll r2 = func(l);
    cout << r1 - r2 + is_prpr(l) << '\n';

}