#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

const ll INF = 2e18;

ll func(ll k, ll n, vll& vec) {
    ll maxi = -INF;
    for (ll mask = 1; mask < (1ll << n); ++mask) {
        ll cnt = 0;
        for (ll i = 0; i < n; ++i)
            cnt += bool(mask & (1ll << i));
        if (cnt == k && (mask & (1ll << 0))) {
            ll mx = -INF, mn = INF;
            ll sum = -INF;
            for (ll i = 0; i < n; ++i) {
                if (mask & (1ll << i)) {
                    if (sum != -INF)
                        mn = min(sum, mn);
                    mx = max(sum, mx);
                    sum = vec[i];
                } else {
                    sum += vec[i];
                }
            }
            mn = min(sum, mn);
            mx = max(sum, mx);
            maxi = max(maxi, mx - mn);
        }
    }
    return maxi;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll n, k;
    cin >> n >> k;
    vll vec(n);
    vll p(n + 1);
    vll minp(n + 1);
    vll mins(n + 1);
    minp[0] = INF;
    mins[n] = INF;
    for (ll i = 0; i < n; i++) {
        cin >> vec[i];
        p[i + 1] = p[i] + vec[i];
        minp[i + 1] = min(minp[i], vec[i]);
    }

    for (int i = n - 1; i >= 0; --i) {
        mins[i] = min(mins[i + 1], vec[i]);
    }

    if (k == 2) {
        ll window = n - (k - 1);
        ll maxi = -INF;
        for (ll r = window - 1; r < n; ++r) {
            ll l = r - window + 1;
            ll summa = p[r + 1] - p[l];
            ll minil = minp[l];
            ll minir = mins[r + 1];
            maxi = max(maxi, summa - min(minil, minir));
        }
        cout << maxi;
    } else {
        cout << func(k, n, vec);
    }
}