#include <bits/stdc++.h>

using namespace std;

using ll = int;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

#pragma GCC optimize("O3")

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll n, m, k;
    cin >> n >> m >> k;
    vector<pll> vec(k, {0, 0});
    for (int i = 0; i < k; i++)
        cin >> vec[i].first >> vec[i].second;

    vector<pair<pll, vector<vll>>> s;
    vector<vll> vv(n, vll(m, 0));
    vv[0][0] = 1;
    s.push_back({{0, 0}, vv});

    vector<pair<pll, vector<vll>>> t;
    while (s.size()) {
        auto p = s.back();
        s.pop_back();
        pll v = p.first;
        if (v == pll{n - 1, m - 1}) {
            t.push_back(p);
            continue;
        }
        if (v.first + 1 < n && p.second[v.first + 1][v.second] == 0) {
            vector<vll> vwas1(all(p.second));
            vwas1[v.first + 1][v.second] = 1;
            s.push_back({{v.first + 1, v.second}, vwas1});
        }

        if (v.second + 1 < m && p.second[v.first][v.second + 1] == 0) {
            vector<vll> vwas1(all(p.second));
            vwas1[v.first][v.second + 1] = 1;
            s.push_back({{v.first, v.second + 1}, vwas1});
        }
    }

    vector<pair<pll, vector<vll>>> t2;
    while (t.size()) {
        auto p = t.back();
        t.pop_back();
        pll v = p.first;
        if (v == pll{0, 0}) {
            t2.push_back(p);
            continue;
        }

        if (pll {v.first - 1, v.second} == pll{0, 0} || (0 <= v.first - 1 && p.second[v.first - 1][v.second] == 0)) {
            vector<vll> vwas1(all(p.second));
            vwas1[v.first - 1][v.second] = 1;
            t.push_back({{v.first - 1, v.second}, vwas1});
        }

        if (pll {v.first, v.second - 1} == pll{0, 0} || (0 <= v.second - 1 && p.second[v.first][v.second - 1] == 0)) {
            vector<vll> vwas1(all(p.second));
            vwas1[v.first][v.second - 1] = 1;
            t.push_back({{v.first, v.second - 1}, vwas1});
        }
    }

    ll cnt = 0;
    for (auto p : t2) {
        bool f = true;
        for (auto d : vec) {
            f &= p.second[d.first - 1][d.second - 1];
            if (!f)
                break;
        }
        if (f)
            cnt++;
    }
    cout << cnt;
}