#include <bits/stdc++.h>

using namespace std;

using ll = int;
using vll = vector<ll>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rev(x) (x).rbegin(), (x).rend()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> uid(a, b);
    return uid(rng);
}

#pragma GCC optimize("O3")

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed;
    cout.precision(8);

    ll n, m, k;
    cin >> n >> m >> k;
    vector<pll> vec(k, {0, 0});
    for (int i = 0; i < k; i++)
        cin >> vec[i].first >> vec[i].second;

    vector<pair<pll, vector<pll>>> s;
    vector<pll> vv = {{0, 0}};
    s.push_back({{0, 0}, vv});

    vector<pair<pll, vector<pll>>> t;
    while (s.size()) {
        auto p = s.back();
        s.pop_back();
        pll v = p.first;
        if (v == pll{n - 1, m - 1}) {
            t.push_back(p);
            continue;
        }
        if (v.first + 1 < n && find(all(p.second), pll{v.first + 1, v.second}) == p.second.end()) {
            vector<pll> vwas1(all(p.second));
            vwas1.push_back({v.first + 1, v.second});
            s.push_back({{v.first + 1, v.second}, vwas1});
        }

        if (v.second + 1 < m && find(all(p.second), pll{v.first, v.second + 1}) == p.second.end()) {
            vector<pll> vwas1(all(p.second));
            vwas1.push_back({v.first, v.second + 1});
            s.push_back({{v.first, v.second + 1}, vwas1});
        }
    }

    vector<pair<pll, vector<pll>>> t2;
    while (t.size()) {
        auto p = t.back();
        t.pop_back();
        pll v = p.first;
        if (v == pll{0, 0}) {
            t2.push_back(p);
            continue;
        }

        if (pll {v.first - 1, v.second} == pll{0, 0} || (0 <= v.first - 1 && find(all(p.second), pll{v.first - 1, v.second}) == p.second.end())) {
            vector<pll> vwas1(all(p.second));
            vwas1.push_back({v.first - 1, v.second});
            t.push_back({{v.first - 1, v.second}, vwas1});
        }

        if (pll {v.first, v.second - 1} == pll{0, 0} || (0 <= v.second - 1 && find(all(p.second), pll{v.first, v.second - 1}) == p.second.end())) {
            vector<pll> vwas1(all(p.second));
            vwas1.push_back({v.first, v.second - 1});
            t.push_back({{v.first, v.second - 1}, vwas1});
        }
    }

    ll cnt = 0;
    for (auto p : t2) {
        bool f = true;
        for (auto d : vec) {
            f &= (find(all(p.second), pll{d.first - 1, d.second - 1}) != p.second.end());
            if (!f)
                break;
        }
        if (f)
            cnt++;
    }
    cout << cnt;
}